Index: trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 487)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 492)
@@ -242,11 +242,8 @@
 SamplingPreprocessor::ComputeVisibility()
 {
-  // pickup an object
-  ObjectContainer objects;
   
   /// rays per pass
   RayContainer passRays;
 
-  mSceneGraph->CollectObjects(&objects);
 
   mViewCellsManager->SetViewSpaceBox(mKdTree->GetBox());
@@ -270,8 +267,8 @@
 		int reverseSamples = 0;
 		
-		for (i = 0; i < objects.size(); i++) {
+		for (i = 0; i < mObjects.size(); i++) {
 						
 			KdNode *nodeToSample = NULL;
-			Intersectable *object = objects[i];
+			Intersectable *object = mObjects[i];
 		
 			int pvsSize = 0;
@@ -339,5 +336,5 @@
 		// cast rays for view cells construction
 		ProcessViewCells(passRays,
-						 objects,
+						 mObjects,
 						 passSampleContributions,
 						 passContributingSamples);
@@ -361,5 +358,5 @@
 				 << "k   #SampleContributions=" << passSampleContributions << " (" 
 				 << 100*passContributingSamples/(float)passSamples<<"%)" << " avgPVS="
-				 << (float)pvsSize /(float)objects.size() << endl 
+				 << (float)pvsSize /(float)mObjects.size() << endl 
 				 << "avg ray contrib=" << avgRayContrib << endl
 				 << "reverse samples [%]" << reverseSamples/(float)passSamples*100.0f << endl;
@@ -371,5 +368,5 @@
 			"#SampleContributions\n" << passSampleContributions << endl << 
 			"#PContributingSamples\n"<<100*passContributingSamples/(float)passSamples<<endl <<
-			"#AvgPVS\n"<< pvsSize/(float)objects.size() << endl <<
+			"#AvgPVS\n"<< pvsSize/(float)mObjects.size() << endl <<
 			"#AvgRayContrib\n" << avgRayContrib << endl;
 	}
@@ -387,5 +384,5 @@
 	// construct view cells if not already constructed
 	if (!mViewCellsManager->ViewCellsConstructed())
-		mViewCellsManager->Construct(objects, mVssSampleRays);
+	  mViewCellsManager->Construct(mObjects, mVssSampleRays);
 
 	// $$JB temporary removed
Index: trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.h	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.h	(revision 492)
@@ -4,4 +4,5 @@
 #include <fstream>
 using namespace std;
+
 
 #include "Preprocessor.h"
@@ -14,4 +15,5 @@
     sampling of view space */
 class RssPreprocessor : public Preprocessor {
+  
 public:
   int mPass;
@@ -29,4 +31,7 @@
   bool mUseViewcells;
   bool mUpdateSubdivision;
+
+  bool mObjectBasedSampling;
+  bool mDirectionalSampling;
   
   AxisAlignedBox3 *mViewSpaceBox;
@@ -34,5 +39,4 @@
   ofstream mStats;
 
-  ObjectContainer mObjects;
 
   // rays cast during the processing
@@ -56,5 +60,10 @@
 			   AxisAlignedBox3 *viewSpaceBox
 			   );
-	
+
+  Vector3
+  InitialGetDirection(const Vector3 &viewpoint,
+					  AxisAlignedBox3 *viewSpaceBox
+					  );
+
   void
   SetupRay(Ray &ray, 
@@ -118,4 +127,8 @@
 			);
 
+
+  void
+  ComputeRenderError();
+
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 486)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 492)
@@ -301,6 +301,6 @@
       maxx = t1;
     }
-    if (maxx < 0.0)
-      return 0;
+	//    if (maxx < 0.0)
+	//      return 0;
   }
 
@@ -327,6 +327,6 @@
       maxx = t1;
     }
-    if (maxx < 0.0)
-      return 0;
+	//    if (maxx < 0.0)
+	//      return 0;
   }
 
@@ -355,6 +355,6 @@
       maxx = t1;
     }
-    if (maxx < 0.0)
-      return 0;
+	//    if (maxx < 0.0)
+	//      return 0;
   }
 
@@ -1774,4 +1774,137 @@
 
 
+  // Compute tmin and tmax for a ray, whenever required .. need not pierce box
+int
+AxisAlignedBox3::ComputeMinMaxT(const Vector3 &origin,
+								const Vector3 &direction,
+								float *tmin,
+								float *tmax) const
+{
+
+  register float minx, maxx;
+
+  
+  Vector3 invDirection;
+  const float eps = 1e-6;
+  const float invEps = 1e6;
+  
+  // it does change the ray direction very slightly,
+  // but the size direction vector is not practically changed
+  
+  if (fabs(direction.x) < eps) {
+    if (direction.x < 0.0)
+      invDirection.x = -invEps;
+    else
+      invDirection.x = invEps;
+  }
+  else
+    invDirection.x = 1.0 / direction.x;
+  
+  if (fabs(direction.y) < eps) {
+    if (direction.y < 0.0)
+      invDirection.y = -invEps;
+    else
+      invDirection.y = invEps;
+  }
+  else
+    invDirection.y = 1.0 / direction.y;
+  
+  if (fabs(direction.z) < eps) {
+    if (direction.z < 0.0)
+      invDirection.z = -invEps;
+    else
+      invDirection.z = invEps;
+  }
+  else
+    invDirection.z = 1.0 / direction.z;
+
+
+  
+  if (fabs(direction.x) < 0.001) {
+    if (mMin.x < origin.x && mMax.x > origin.x) {
+      minx = -MAXFLOAT;
+      maxx = MAXFLOAT;
+    }
+    else
+      return 0;
+  }
+  else {
+    float t1 = (mMin.x - origin.x) * invDirection.x;
+    float t2 = (mMax.x - origin.x) * invDirection.x;
+    if (t1 < t2) {
+      minx = t1;
+      maxx = t2;
+    }
+    else {
+      minx = t2;
+      maxx = t1;
+    }
+	//    if (maxx < 0.0)
+	//      return 0;
+  }
+
+  *tmin = minx;
+  *tmax = maxx;
+  
+  if (fabs(direction.y) < 0.001) {
+    if (mMin.y < origin.y && mMax.y > origin.y) {
+      minx = -MAXFLOAT;
+      maxx = MAXFLOAT;
+    }
+    else
+      return 0;
+  }
+  else {
+    float t1 = (mMin.y - origin.y) * invDirection.y;
+    float t2 = (mMax.y - origin.y) * invDirection.y;
+    if (t1 < t2) {
+      minx = t1;
+      maxx = t2;
+    }
+    else {
+      minx = t2;
+      maxx = t1;
+    }
+	//    if (maxx < 0.0)
+	//      return 0;
+  }
+
+  if (minx > *tmin)
+    *tmin = minx;
+  if (maxx < *tmax)
+    *tmax = maxx;
+  
+  if (fabs(direction.z) < 0.001) {
+    if (mMin.z < origin.z && mMax.z > origin.z) {
+      minx = -MAXFLOAT;
+      maxx = MAXFLOAT;
+    }
+    else
+      return 0;
+  }
+  else {
+    float t1 = (mMin.z - origin.z) * invDirection.z;
+    float t2 = (mMax.z - origin.z) * invDirection.z;
+    if (t1 < t2) {
+      minx = t1;
+      maxx = t2;
+    }
+    else {
+      minx = t2;
+      maxx = t1;
+    }
+	//    if (maxx < 0.0)
+	//      return 0;
+  }
+
+  if (minx > *tmin)
+    *tmin = minx;
+  if (maxx < *tmax)
+    *tmax = maxx;
+
+  return 1; // yes, intersection was found
+}
+
+
 bool AxisAlignedBox3::GetIntersectionFace(Rectangle3 &face, 
 										  const AxisAlignedBox3 &neighbour) const
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp	(revision 466)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp	(revision 492)
@@ -11,4 +11,5 @@
 #include "Mesh.h"
 #include "Exporter.h"
+#include "SceneGraph.h"
 
 
@@ -33,6 +34,7 @@
 bool
 Camera::SnapImage(string filename,
-		  KdTree *tree
-		  )
+				  KdTree *tree,
+				  SceneGraph *sceneGraph
+				  )
 {
   int x;
@@ -59,23 +61,25 @@
       SetupRay(ray, x, mHeight - (y + 1));
       if (tree->CastRay(ray))
-	if (ray.intersections.size()) {
-	  sort(ray.intersections.begin(), ray.intersections.end());
-	  MeshInstance *mesh = (MeshInstance*)ray.intersections[0].mObject;
-	  RgbColor color(1,1,1);
-	  if (mesh->GetMesh()->mMaterial)
-	    color = mesh->GetMesh()->mMaterial->mDiffuseColor;
-
-	  pbuffer[0] = color.r;
-	  pbuffer[1] = color.g;
-	  pbuffer[2] = color.b;
-	  pbuffer[3] = 1.0f;
-
-	}
+		if (ray.intersections.size()) {
+		  sort(ray.intersections.begin(), ray.intersections.end());
+		  MeshInstance *mesh = (MeshInstance*)ray.intersections[0].mObject;
+		  RgbColor color(1,1,1);
+		  if (mesh->GetMesh()->mMaterial)
+			color = mesh->GetMesh()->mMaterial->mDiffuseColor;
+		  
+		  pbuffer[0] = color.r;
+		  pbuffer[1] = color.g;
+		  pbuffer[2] = color.b;
+		  pbuffer[3] = 1.0f;
+		  
+		}
       pbuffer+=components;
       
-      if (exportRays && (x==222) && (y==97)) {
-				Ray *nray = new Ray(ray);
-				rays.push_back(nray);
-			}
+	  //      if (exportRays && ( 1||(x==222) && (y==97))) {
+	  //	  if (exportRays && ((x%4==0) && (y%4==0))) {
+	  if (exportRays && ray.intersections.empty()) {
+		Ray *nray = new Ray(ray);
+		rays.push_back(nray);
+	  }
     }
     //    pbuffer-=2*components*mWidth;
@@ -85,38 +89,42 @@
   cout<<"#RAY_CAST_TIME\n";
   cout<<TimeDiff(t1, t2)<<"\n";
-
+  
   
   cout<<"Saving image"<<endl;
-
+  
   ilRegisterType(IL_FLOAT);
   ilTexImage(mWidth, mHeight, 1, 4, IL_RGBA, IL_FLOAT, buffer);
   ilSaveImage((char *const)filename.c_str());
   delete buffer;
+
+  cout<<"done."<<endl<<flush;
   
   Exporter *exporter = NULL;
-  if (exportRays) {
+  if (1) {
     exporter = Exporter::GetExporter(filename + "-rays" + ".x3d");
-    exporter->SetWireframe();
-    exporter->ExportKdTree(*tree);
-		//exporter->ExportBspTree(*bsptree);
-    exporter->ExportRays(rays, 10000);
+    exporter->SetFilled();
+	if (sceneGraph)
+	  exporter->ExportScene(sceneGraph->mRoot);
+	
+    //exporter->ExportKdTree(*tree);
+	//exporter->ExportBspTree(*bsptree);
+    exporter->ExportRays(rays, 2000);
     exporter->SetFilled();
     int k =0;
     for (int j=0; j < rays.size(); j++)
       if (rays[j]->kdLeaves.size()) {
-				Ray *ray = rays[j];
-				int i;
-				if (1)
-					for (i= 0; i < ray->kdLeaves.size(); i++)
-						exporter->ExportBox(tree->GetBox(ray->kdLeaves[i]));
-				if (0)
-					for (i= 0; i < ray->testedObjects.size(); i++)
-						exporter->ExportIntersectable(ray->testedObjects[i]);
-				
+		Ray *ray = rays[j];
+		int i;
+		if (0)
+		  for (i= 0; i < ray->kdLeaves.size(); i++)
+			exporter->ExportBox(tree->GetBox(ray->kdLeaves[i]));
+		if (0)
+		  for (i= 0; i < ray->testedObjects.size(); i++)
+			exporter->ExportIntersectable(ray->testedObjects[i]);
+		
       }
-		
+	
     delete exporter;
   }
-  
   
   return true;
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 492)
@@ -330,41 +330,72 @@
 void ViewCellsManager::ComputeSampleContributions(VssRay &ray)
 {
-	ViewCellContainer viewcells;
-		
-	ray.mPvsContribution = 0;
-	ray.mRelativePvsContribution = 0.0f;
-
-	// matt TODO: remove this!!
-	Ray hray(ray);
-	float tmin = 0, tmax = 1.0;
-	
-	//hray.Init(ray.GetOrigin(), ray.GetDir(), Ray::LINE_SEGMENT);
-	if (!GetSceneBbox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
-		return;
-
-	Vector3 origin = hray.Extrap(tmin);
-	Vector3 termination = hray.Extrap(tmax);
-	
-	CastLineSegment(origin,
-					termination,
-					viewcells);
+
+
+
+  ViewCellContainer viewcells;
+		
+  ray.mPvsContribution = 0;
+  ray.mRelativePvsContribution = 0.0f;
+
+  // matt TODO: remove this!!
+  Ray hray(ray);
+  float tmin = 0, tmax = 1.0;
   
-	ViewCellContainer::const_iterator it = viewcells.begin();
-	
-	for (; it != viewcells.end(); ++it) 
-	{ 	
-		ViewCell *viewcell = *it;
-	
-		// if ray not outside of view space
-		float contribution;
-		bool added = 
-			viewcell->GetPvs().AddSample(ray.mTerminationObject,
-										 contribution);
-		
-		if (added)
-			++ ray.mPvsContribution;
-		
-		ray.mRelativePvsContribution += contribution;
-	}
+  //hray.Init(ray.GetOrigin(), ray.GetDir(), Ray::LINE_SEGMENT);
+  if (!GetSceneBbox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
+	return;
+  
+  Vector3 origin = hray.Extrap(tmin);
+  Vector3 termination = hray.Extrap(tmax);
+  
+  CastLineSegment(origin,
+				  termination,
+				  viewcells);
+  
+  // copy viewcells memory efficiently
+  const bool storeViewcells = false;
+  if (storeViewcells) {
+	ray.mViewCells.reserve(viewcells.size());
+	ray.mViewCells = viewcells;
+  }
+  
+  ViewCellContainer::const_iterator it = viewcells.begin();
+
+  bool addInPlace = false;
+
+  if (addInPlace) {
+	for (; it != viewcells.end(); ++it) { 	
+	  ViewCell *viewcell = *it;
+	  
+	  // if ray not outside of view space
+	  float contribution;
+	  bool added = 
+		viewcell->GetPvs().AddSample(ray.mTerminationObject,
+									 contribution
+									 );
+	  if (added)
+		ray.mPvsContribution++;
+	  
+	  ray.mRelativePvsContribution += contribution;
+	}
+  } else {
+    for (; it != viewcells.end(); ++it) { 	
+	  ViewCell *viewcell = *it;
+	  // if ray not outside of view space
+	  float contribution;
+	  if (viewcell->GetPvs().GetSampleContribution(ray.mTerminationObject,
+												   contribution
+												   ))
+		ray.mPvsContribution++;
+	  
+	  ray.mRelativePvsContribution += contribution;
+	}
+
+	for (it = viewcells.begin(); it != viewcells.end(); ++it) { 	
+	  ViewCell *viewcell = *it;
+	  // if ray not outside of view space
+	  viewcell->GetPvs().AddSample(ray.mTerminationObject);
+	}
+  }
 }
 
@@ -520,5 +551,5 @@
 #endif
 }
-
+  
 
 float BspViewCellsManager::GetRendercost(ViewCell *viewCell, float objRendercost) const
@@ -1705,9 +1736,16 @@
 									  const VssRayContainer &rays)
 {
-	// if view cells were already constructed
-	if (ViewCellsConstructed())
-		return 0;
-
-	int sampleContributions = 0;
+  // if view cells were already constructed
+  if (ViewCellsConstructed())
+	return 0;
+  
+  Debug << "Constructing bsp view cells" << endl;
+  
+  int sampleContributions = 0;
+  
+  VssRayContainer sampleRays;
+  
+  int limit = min (mConstructionSamples, (int)rays.size());
+
 	
 	VssRayContainer constructionRays;
@@ -2268,5 +2306,15 @@
 		}
 	}
-
 	return maxDist;
 }
+
+
+
+
+ViewCell *
+VspBspViewCellsManager::GetViewCell(const Vector3 &point)
+{
+  if (!mVspBspTree)
+	return NULL;
+  return mVspBspTree->GetViewCell(point);
+}
Index: trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.cpp	(revision 492)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.cpp	(revision 492)
@@ -0,0 +1,491 @@
+#include "Mesh.h"
+#include "GlRenderer.h"
+#include "ViewCellsManager.h"
+#include "SceneGraph.h"
+#include "Pvs.h"
+#include "Viewcell.h"
+
+#include <GL/glext.h>
+
+GlRenderer *renderer = NULL;
+
+#ifdef _WIN32
+PFNGLGENOCCLUSIONQUERIESNVPROC glGenOcclusionQueriesNV;
+PFNGLBEGINOCCLUSIONQUERYNVPROC glBeginOcclusionQueryNV;
+PFNGLENDOCCLUSIONQUERYNVPROC glEndOcclusionQueryNV;
+PFNGLGETOCCLUSIONQUERYUIVNVPROC glGetOcclusionQueryuivNV;
+#endif
+
+GlRenderer::GlRenderer(SceneGraph *sceneGraph,
+				   ViewCellsManager *viewCellsManager):
+  QGLWidget(),
+  mSceneGraph(sceneGraph),
+  mViewCellsManager(viewCellsManager)
+{
+  mSceneGraph->CollectObjects(&mObjects);
+  mViewPoint = mSceneGraph->GetBox().Center();
+  mViewDirection = Vector3(0,0,1);
+  mRender = true;
+
+  //  timerId = startTimer(10);
+  mFrame = 0;
+  mPvsStatFrames = 10000;
+  mPvsErrorBuffer.resize(mPvsStatFrames);
+  ClearErrorBuffer();
+  pbuffer = NULL;
+}
+
+GlRenderer::~GlRenderer()
+{
+  if (pbuffer)
+	delete pbuffer;
+}
+
+void
+GlRenderer::RenderIntersectable(Intersectable *object)
+{
+
+  SetupFalseColor(object->mId);
+
+  switch (object->Type()) {
+  case Intersectable::MESH_INSTANCE:
+	RenderMeshInstance((MeshInstance *)object);
+	break;
+  default:
+	cerr<<"Rendering this object not yet implemented\n";
+	break;
+  }
+}
+
+
+void
+GlRenderer::RenderMeshInstance(MeshInstance *mi)
+{
+  RenderMesh(mi->GetMesh());
+}
+
+void
+GlRenderer::SetupFalseColor(const int id)
+{
+  // swap bits of the color
+  
+  glColor3ub(id&255, (id>>8)&255, (id>>16)&255);
+}
+
+void
+GlRenderer::SetupMaterial(Material *m)
+{
+  if (m)
+	glColor3fv(&(m->mDiffuseColor.r));
+  else
+	glColor3f(1.0f, 1.0f, 1.0f);
+}
+
+void
+GlRenderer::RenderMesh(Mesh *mesh)
+{
+  int i = 0;
+
+  if (!mUseFalseColors)
+	SetupMaterial(mesh->mMaterial);
+  
+  for (i=0; i < mesh->mFaces.size(); i++) {
+	glBegin(GL_POLYGON);
+	Face *face = mesh->mFaces[i];
+	for (int j = 0; j < face->mVertexIndices.size(); j++) {
+	  glVertex3fv(&mesh->mVertices[face->mVertexIndices[j]].x);
+	}
+	glEnd();
+  }
+}
+	
+void
+GlRenderer::initializeGL()
+{
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  
+  glMatrixMode(GL_MODELVIEW);
+  glLoadIdentity();
+
+  glEnable(GL_CULL_FACE);
+  glShadeModel(GL_FLAT);
+  glEnable(GL_DEPTH_TEST);
+  glEnable(GL_CULL_FACE);
+  
+  glGenOcclusionQueriesNV = (PFNGLGENOCCLUSIONQUERIESNVPROC)
+	wglGetProcAddress("glGenOcclusionQueriesNV");
+  glBeginOcclusionQueryNV = (PFNGLBEGINOCCLUSIONQUERYNVPROC)
+	wglGetProcAddress("glBeginOcclusionQueryNV");
+  glEndOcclusionQueryNV = (PFNGLENDOCCLUSIONQUERYNVPROC)
+	wglGetProcAddress("glEndOcclusionQueryNV");
+  glGetOcclusionQueryuivNV = (PFNGLGETOCCLUSIONQUERYUIVNVPROC)
+	wglGetProcAddress("glGetOcclusionQueryuivNV");
+}
+
+void
+GlRenderer::resizeGL(int w, int h)
+{
+  SetupProjection(w, h);
+
+  if (pbuffer == NULL || pbuffer->size().width() != w || pbuffer->size().height() != h) {
+	if (pbuffer)
+	  delete pbuffer;
+	pbuffer = new QGLPbuffer(QSize(w,h));
+  }
+  
+  updateGL();
+}
+
+
+void
+GlRenderer::SetupProjection(const int w, const int h)
+{
+  glViewport(0, 0, w, h);
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  gluPerspective(70.0, 1.0, 0.1, 2.0*Magnitude(mSceneGraph->GetBox().Diagonal()));
+  glMatrixMode(GL_MODELVIEW);
+}
+
+void
+GlRenderer::SetupCamera()
+{
+  Vector3 target = mViewPoint + mViewDirection;
+  Vector3 up(0,1,0);
+  
+  glLoadIdentity();
+  gluLookAt(mViewPoint.x, mViewPoint.y, mViewPoint.z,
+			target.x, target.y, target.z,
+			up.x, up.y, up.z);
+}
+
+void
+GlRenderer::RandomViewPoint()
+{
+  Vector3 pVector = Vector3(halton.GetNumber(1),
+							halton.GetNumber(2),
+							halton.GetNumber(3));
+  
+  Vector3 dVector = Vector3(2*M_PI*halton.GetNumber(4),
+							M_PI*halton.GetNumber(5),
+							0.0f);
+  
+  mViewPoint = mSceneGraph->GetBox().GetPoint(pVector);
+  
+  mViewDirection = Normalize(Vector3(sin(dVector.x),
+									 //									 cos(dVector.y),
+									 0.0f,
+									 cos(dVector.x)));
+
+  halton.GenerateNext();
+}
+
+void
+GlRenderer::paintGL()
+{
+  if (mRender) {
+	Render();
+	mFrame++;
+  }
+}
+
+void
+GlRenderer::ClearErrorBuffer()
+{
+  for (int i=0; i < mPvsStatFrames; i++) {
+	mPvsErrorBuffer[i] = 1.0f;
+  }
+}
+
+void
+GlRenderer::EvalPvsStat()
+{
+  mPvsStat.Reset();
+  halton.Reset();
+
+  pbuffer->makeCurrent();
+  initializeGL();
+  SetupProjection(pbuffer->size().width(), pbuffer->size().height());
+  
+  for (int i=0; i < mPvsStatFrames; i++) {
+	float err;
+	RandomViewPoint();
+	if (mPvsErrorBuffer[i] > 0.0f) {
+	  mPvsErrorBuffer[i] = GetPixelError();
+	  cout<<"("<<i<<","<<mPvsErrorBuffer[i]<<")";
+	  //	  swapBuffers();
+	}
+	
+	err = mPvsErrorBuffer[i];
+	
+	if (err >= 0.0f) {
+	  if (err > mPvsStat.maxError)
+		mPvsStat.maxError = err;
+	  mPvsStat.sumError += err;
+	  if (err == 0.0f)
+		mPvsStat.errorFreeFrames++;
+	  mPvsStat.frames++;
+	}
+  }
+  
+  pbuffer->doneCurrent();
+
+  cout<<endl<<flush;
+  mRenderingFinished.wakeAll();
+}
+
+float
+GlRenderer::Render()
+{
+  float pErrorPixels = -1.0f;
+
+  glReadBuffer(GL_BACK);
+  
+  mUseFalseColors = true;
+
+  SetupCamera();
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+  glEnable( GL_CULL_FACE );
+  
+  ObjectContainer::const_iterator oi = mObjects.begin();
+  for (; oi != mObjects.end(); oi++)
+	RenderIntersectable(*oi);
+
+  ViewCell *viewcell = mViewCellsManager->GetViewCell(mViewPoint);
+  
+  QImage im1, im2;
+  QImage diff;
+  
+  if (viewcell) {
+	// read back the texture
+	im1 = grabFrameBuffer(true);
+	
+	SetupCamera();
+	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+	
+	std::map<Intersectable *,
+	  PvsData<Intersectable *>,
+	  LtSample<Intersectable *> >::const_iterator it = viewcell->GetPvs().mEntries.begin();
+	
+	for (; it != viewcell->GetPvs().mEntries.end(); ++ it) {
+	  Intersectable *object = (*it).first;
+	  RenderIntersectable(object);
+	}
+
+	// read back the texture
+	im2 = grabFrameBuffer(true);
+	
+	diff = im1;
+	int x, y;
+	int errorPixels = 0;
+	
+	for (y = 0; y < im1.height(); y++)
+	  for (x = 0; x < im1.width(); x++)
+		if (im1.pixel(x, y) == im2.pixel(x, y))
+		  diff.setPixel(x, y, qRgba(0,0,0,0));
+		else {
+		  diff.setPixel(x, y, qRgba(255,128,128,255));
+		  errorPixels++;
+		}
+	pErrorPixels = (100.f*errorPixels)/(im1.height()*im1.width());
+  }
+
+  // now render the pvs again
+  SetupCamera();
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+  mUseFalseColors = false;
+	
+  oi = mObjects.begin();
+  for (; oi != mObjects.end(); oi++)
+	RenderIntersectable(*oi);
+
+  // now render im1
+  if (viewcell) {
+	// init ortographic projection
+	glMatrixMode(GL_PROJECTION);
+	glPushMatrix();
+	
+	glLoadIdentity();
+	gluOrtho2D(0, 1.0f, 0, 1.0f);
+	
+	glMatrixMode(GL_MODELVIEW);
+	glLoadIdentity();
+	
+	bindTexture(diff);
+	
+	glPushAttrib(GL_ENABLE_BIT);
+	glEnable( GL_ALPHA_TEST );
+	glDisable( GL_CULL_FACE );
+	glAlphaFunc( GL_GREATER, 0.5 );
+	
+	glEnable( GL_TEXTURE_2D );
+	glBegin(GL_QUADS);
+	
+	glTexCoord2f(0,0);
+	glVertex3f(0,0,0);
+	
+	glTexCoord2f(1,0);
+	glVertex3f( 1, 0, 0);
+	
+	glTexCoord2f(1,1);
+	glVertex3f( 1, 1, 0);
+	
+	glTexCoord2f(0,1);
+	glVertex3f(0, 1, 0);
+	glEnd();
+	
+	glPopAttrib();
+	
+	// restore the projection matrix
+	glMatrixMode(GL_PROJECTION);
+	glPopMatrix();
+	glMatrixMode(GL_MODELVIEW);
+  }
+
+  return pErrorPixels;
+}
+
+void
+GlRenderer::RenderScene()
+{
+  static int glList = -1;
+  if (glList != -1) {
+	glCallList(glList);
+  } else {
+	glList = glGenLists(1);
+	glNewList(glList, GL_COMPILE_AND_EXECUTE);
+	ObjectContainer::const_iterator oi = mObjects.begin();
+	for (; oi != mObjects.end(); oi++)
+	  RenderIntersectable(*oi);
+	glEndList();
+  }
+}
+
+float
+GlRenderer::GetPixelError()
+{
+  float pErrorPixels = -1.0f;
+
+  glReadBuffer(GL_BACK);
+  
+  mUseFalseColors = true;
+
+  SetupCamera();
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+  glEnable( GL_CULL_FACE );
+  
+  RenderScene();
+
+  // now check whether any backfacing polygon would pass the depth test
+  static int query = -1;
+  if (query == -1)
+	glGenOcclusionQueriesNV(1, (unsigned int *)&query);
+  
+  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
+  glDepthMask(GL_FALSE);
+  glDisable( GL_CULL_FACE );
+  
+  glBeginOcclusionQueryNV(query);
+  
+  RenderScene();
+  
+  glEndOcclusionQueryNV();
+
+  // at this point, if possible, go and do some other computation
+  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
+  glDepthMask(GL_TRUE);
+  glEnable( GL_CULL_FACE );
+  
+  unsigned int pixelCount;
+  // reenable other state
+  glGetOcclusionQueryuivNV(query,
+						   GL_PIXEL_COUNT_NV,
+						   &pixelCount);
+
+  if (pixelCount > 0)
+	return -1.0f; // backfacing polygon found -> not a valid viewspace sample
+
+  ViewCell *viewcell = mViewCellsManager->GetViewCell(mViewPoint);
+  
+  if (viewcell) {
+	SetupCamera();
+	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+
+	// Render PVS
+	std::map<Intersectable *,
+	  PvsData<Intersectable *>,
+	  LtSample<Intersectable *> >::const_iterator it = viewcell->GetPvs().mEntries.begin();
+	
+	for (; it != viewcell->GetPvs().mEntries.end(); ++ it) {
+	  Intersectable *object = (*it).first;
+	  RenderIntersectable(object);
+	}
+
+	glBeginOcclusionQueryNV(query);
+
+	SetupCamera();
+
+	RenderScene();
+	
+	glEndOcclusionQueryNV();
+	
+
+	unsigned int pixelCount;
+	// reenable other state
+	glGetOcclusionQueryuivNV(query,
+							 GL_PIXEL_COUNT_NV,
+							 &pixelCount);
+	
+	pErrorPixels = (100.f*pixelCount)/(height()*width());
+  }
+  
+  return pErrorPixels;
+}
+
+
+void
+GlRenderer::mousePressEvent(QMouseEvent *e)
+{
+  int x = e->pos().x();
+  int y = e->pos().y();
+
+  mousePoint.x = x;
+  mousePoint.y = y;
+  
+}
+
+void
+GlRenderer::mouseMoveEvent(QMouseEvent *e)
+{
+  float MOVE_SENSITIVITY = Magnitude(mSceneGraph->GetBox().Diagonal())*1e-3;
+  float TURN_SENSITIVITY=0.1f;
+  float TILT_SENSITIVITY=32.0 ;
+  float TURN_ANGLE= M_PI/36.0 ;
+
+  int x = e->pos().x();
+  int y = e->pos().y();
+  
+  if (e->modifiers() & Qt::ControlModifier) {
+	mViewPoint.y += (y-mousePoint.y)*MOVE_SENSITIVITY/2.0;
+	mViewPoint.x += (x-mousePoint.x)*MOVE_SENSITIVITY/2.0;
+  } else {
+	mViewPoint += mViewDirection*((mousePoint.y - y)*MOVE_SENSITIVITY);
+	float adiff = TURN_ANGLE*(x - mousePoint.x)*-TURN_SENSITIVITY;
+	float angle = atan2(mViewDirection.x, mViewDirection.z);
+	mViewDirection.x = sin(angle+adiff);
+	mViewDirection.z = cos(angle+adiff);
+  }
+  
+  mousePoint.x = x;
+  mousePoint.y = y;
+  
+  updateGL();
+}
+
+void
+GlRenderer::mouseReleaseEvent(QMouseEvent *)
+{
+
+
+}
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp	(revision 485)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp	(revision 492)
@@ -103,6 +103,6 @@
 	
   for ( ;
-				faceIndex < mFaces.size();
-				faceIndex++) {
+		faceIndex < mFaces.size();
+		faceIndex++) {
     hits += CastRayToFace(faceIndex, ray, nearestT, nearestFace, instance);
     if (mIsConvex && nearestFace != -1)
@@ -122,8 +122,8 @@
 int
 Mesh::CastRayToSelectedFaces(
-														 Ray &ray,
-														 const vector<int> &faces,
-														 Intersectable *instance
-														 )
+							 Ray &ray,
+							 const vector<int> &faces,
+							 Intersectable *instance
+							 )
 {
   vector<int>::const_iterator fi;
@@ -160,11 +160,10 @@
 inline int
 int_lineseg(float px,
-						float py,
-						float u1,
-						float v1,
-						float u2,
-						float v2)
-{
-  float t;
+			float py,
+			float u1,
+			float v1,
+			float u2,
+			float v2)
+{
   float ydiff;
 
@@ -183,12 +182,19 @@
   if (fabs(ydiff) < Limits::Small) {	  // denominator near 0
     if (((fabs(v1) > Limits::Small) ||
-				 (u1 > 0) || (u2 > 0)))
+		 (u1 > 0) || (u2 > 0)))
       return 0;
     return 1;
   }
-
-  t = -v1 / ydiff;		  // Compute parameter
-
-  return (u1 + t * (u2 - u1)) > 0;
+  
+  double t = -v1 / ydiff;		  // Compute parameter
+
+  double thresh;
+  if (ydiff < 0.0f)
+	thresh = -1e20;
+  else
+	thresh = 1e20;
+
+  
+  return (u1 + t * (u2 - u1)) > thresh; //-Limits::Small;
 }
 
@@ -198,8 +204,8 @@
 int
 Mesh::RayFaceIntersection(const int faceIndex,
-													const Ray &ray,
-													float &t,
-													const float nearestT
-													)
+						  const Ray &ray,
+						  float &t,
+						  const float nearestT
+						  )
 {
   Face *face  = mFaces[faceIndex];
@@ -244,6 +250,6 @@
       mVertices[face->mVertexIndices[i]].ExtractVerts(&u2, &v2, paxis);
       // line u1, v1, u2, v2
-      if ((v2 - v1)*(u1 - u) > (u2 - u1)*(v1 - v))
-				return Ray::NO_INTERSECTION;
+      if ((v1 - v2)*(u - u1) + (u2 - u1)*(v - v1) > 0)
+		return Ray::NO_INTERSECTION;
       u1 = u2;
       v1 = v2;
@@ -416,6 +422,6 @@
 int
 TransformedMeshInstance::CastRay(
-																 Ray &ray
-																 )
+								 Ray &ray
+								 )
 {
   ray.ApplyTransform(Invert(mWorldTransform));
